module test_f90_def
  implicit none
  type test_t
     character(len=5) :: name
     real             :: x(3)
     integer          :: a(2) 
  end type test_t
  interface operator(==)
     module procedure test_t_ss, test_t_aa
  end interface
contains 
  function test_t_ss(a,b) result(r)
    type(test_t), intent(in) :: a
    type(test_t), intent(in) :: b
    logical              :: r
    r = (a%name==b%name) .and. all(a%x==b%x) .and. all(a%a==b%a)
  end function test_t_ss
  function test_t_aa(a,b) result(r)
    type(test_t), intent(in) :: a(:)
    type(test_t), intent(in) :: b(size(a))
    logical              :: r(size(a))
    integer i
    do i= 1,size(a)
       r(i) = (a(i)==b(i))
    end do
  end function test_t_aa
  
end module test_f90_def
