module mpi
  use mpi_uses
contains
  subroutine fmpi_init(ierror)
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o
    external mpi_init
    
    call mpi_init(ierror_o)
    call fmpi_def_init()
    call init_all_mpi_def               ! Define derived types
    call fmpi_set_comm(FMPI_COMM_WORLD) ! Set the communicator size, rank etc
    if (present(ierror)) ierror = ierror_o
  end subroutine fmpi_init
end module mpi
 
